SoLevelOfDetail(3)

NAME
SoLevelOfDetail - The SoLevelOfDetail class is used to choose a child based on projected size.

SYNOPSIS

#include <Inventor/nodes/SoLevelOfDetail.h>

Inherits SoGroup.

  Public Member Functions
virtual SoType getTypeId (void) const
SoLevelOfDetail (void)
SoLevelOfDetail (int numchildren)
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void notify (SoNotList *nl)
Public Member Functions inherited from SoGroup
SoGroup (void)
SoGroup (int nchildren)
virtual void addChild (SoNode *node)
virtual void insertChild (SoNode *child, int newchildindex)
virtual SoNode * getChild (int index) const
virtual int findChild (const SoNode *node) const
virtual int getNumChildren (void) const
virtual void removeChild (int childindex)
virtual void removeChild (SoNode *child)
virtual void removeAllChildren (void)
virtual void replaceChild (int index, SoNode *newchild)
virtual void replaceChild (SoNode *oldchild, SoNode *newchild)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void pick (SoPickAction *action)
virtual void search (SoSearchAction *action)
virtual void write (SoWriteAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * getChildren (void) const
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual SbBool affectsState (void) const
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
SbUniqueId getNodeId (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoGroup
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoMFFloat screenArea

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoLevelOfDetail ()
Protected Member Functions inherited from SoGroup
virtual ~SoGroup ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
virtual SbBool readChildren (SoInput *in)
virtual void copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoNotRec createNotRec (void)
void setOperation (const SoNotRec::OperationType opType=SoNotRec::UNSPECIFIED, const SoNode *cc=NULL, const SoNode *pc=NULL, const int ci=-1)
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoGroup
SoChildList * children
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoLevelOfDetail class is used to choose a child based on projected size. A level-of-detail mechanism is typically used by application programmers to assist the library in speeding up the rendering.

The way a level-of-detail mechanism works is basically like this:

Several versions of varying complexity of the same geometry / shape is provided by the application programmer in sorted order from "most complex" to "least complex" (where "complex" in this context should be taken to mean more or less detailed in the number of polygons / shapes used for rendering it).

The runtime rendering system then, upon scene graph traversal, will on-the-fly calculate either the distance from the camera to the 3D-model in question, or the number of pixels in the screen projection of the 3D-model. This value is then used to decide which version of the model to actually render: as the model is moved farther away from the camera, a less detailed version of the model is used. And vice versa, as the model moves closer to the camera, more and more detailed versions of it are rendered.

This is under many different circumstances a very effective way to let the application programmer assist to profoundly optimize the rendering of her 3D-scene.

There is of course a trade-off with the level-of-detail technique: more versions of the same 3D model means the scene graph will use up more application memory resources. Also, generating the set of less and less detailed versions of a 3D model from the original is often not a trivial task to do properly. The process is often assisted by software like what Kongsberg Oil & Gas Technologies offers in their <a href="http://www.rational-reducer.com>Rational Reducer</a> package.The SoLevelOfDetail node implements the "projected size" varietylevel-of-detail technique (as opposed to the "object distance"technique, as done by the SoLOD node).The node works by comparing the current projected size of thesmallest rectangle covering the bounding box of its child geometry.Along with this set of models of the same shape, a specification ofwhen to switch between them is also provided.Example scene graph layout:@code LevelOfDetail { screenArea [ 2000, 500, 50 ] DEF version-0 Separator { # most complex / detailed / heavy version of subgraph } DEF version-1 Separator { # less complex version of subgraph } DEF version-2 Separator { # even less complex version of subgraph } DEF version-3 Separator { # simplest / "lightest" version of subgraph }}\endcodeThe way the above sub-scene graph would work would be the following:if the rectangular area around the model's projected bounding boxcovers \e more than 2000 pixels (meaning it will be up pretty closeto the camera), the most complex version of the model (\c version-0)would be traversed (and rendered, of course). If the projected areawould be \e between 500 and 2000 pixels, the \c version-1 modelwould be used. Ditto if the projected area was between 50 and 500pixels, the \c version-2 version of the model would beused. Finally, if the projected bounding box area would be \e lessthan 50 square pixels, the presumably least detailed version of themodel would be used.(A common "trick" is to let the last of the SoLevelOfDetail node'schildren be just an empty subgraph, so no geometry will be renderedat all if the model is sufficiently far away. This will of coursehave a positive effect on the total rendering time for the completescene graph.)Note that the SoLevelOfDetail::screenArea vector will be influencedby preceding SoComplexity nodes in the following way: ifSoComplexity::value is set from 0.0 up to 0.5, lower detail levelsthan normal will be selected for traversal. If SoComplexity::valueis above 0.5, higher level details than normal will be used. AnSoComplexity::value equal to 1.0 will cause the first child ofSoLevelOfDetail to always be used.As mentioned above, there is one other level-of-detail node in theCoin library: SoLOD. The difference between that one and this isjust that instead of projected bounding box area, SoLOD uses thedistance between the camera and the object to find out when toswitch between the different model versions.Using SoLOD is faster, since figuring out the projected bounding boxarea needs a certain amount of calculations. But usingSoLevelOfDetail is often "better", in the sense that it's really a model's size and visibility in the viewport that determines whether we could switch to a less complex version without losing enough detail that it gives a noticeable visual degradation.

FILE FORMAT/DEFAULTS:

LevelOfDetail {
    screenArea 0
}

See also
    SoLOD

Constructor & Destructor Documentation

  SoLevelOfDetail::SoLevelOfDetail (void )
Default constructor.

  SoLevelOfDetail::SoLevelOfDetail (int numchildren)
Constructor.

The argument should be the approximate number of children which is expected to be inserted below this node. The number need not be exact, as it is only used as a hint for better memory resource allocation.

  SoLevelOfDetail::~SoLevelOfDetail () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoLevelOfDetail::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoLevelOfDetail::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoGroup.

  const SoFieldData ** SoLevelOfDetail::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoLevelOfDetail::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoGroup.

  void SoLevelOfDetail::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoGroup.

  void SoLevelOfDetail::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoGroup.

  void SoLevelOfDetail::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoGroup.

  void SoLevelOfDetail::rayPick (SoRayPickAction * action) [virtual]
Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

  void SoLevelOfDetail::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoGroup.

  void SoLevelOfDetail::audioRender (SoAudioRenderAction * action) [virtual]
Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoGroup.

  void SoLevelOfDetail::notify (SoNotList * l) [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Member Data Documentation

  SoMFFloat SoLevelOfDetail::screenArea
The screen area limits for the children. See usage example in main class documentation of SoLevelOfDetail for an explanation of how this vector should be set up correctly.

By default this vector just contains a single value 0.0f.

Author

Generated automatically by Doxygen for Coin from the source code.